// StuView.cpp : Implementierung der Klasse CStudentView
//

#include "stdafx.h"
#include "ex16b.h"

#include "StuDoc.h"
#include "StuView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CStudentView

IMPLEMENT_DYNCREATE(CStudentView, CFormView)

BEGIN_MESSAGE_MAP(CStudentView, CFormView)
	//{{AFX_MSG_MAP(CStudentView)
	ON_BN_CLICKED(IDC_CLEAR, OnClear)
	ON_COMMAND(ID_STUDENT_HOME, OnCommandHome)
	ON_COMMAND(ID_STUDENT_INS, OnCommandIns)
	ON_COMMAND(ID_STUDENT_NEXT, OnCommandNext)
	ON_COMMAND(ID_STUDENT_PREV, OnCommandPrev)
	ON_COMMAND(ID_STUDENT_END, OnCommandEnd)
	ON_COMMAND(ID_STUDENT_DEL, OnCommandDel)
	ON_UPDATE_COMMAND_UI(ID_STUDENT_HOME, OnUpdateCommandHome)
	ON_UPDATE_COMMAND_UI(ID_STUDENT_END, OnUpdateCommandEnd)
	ON_UPDATE_COMMAND_UI(ID_STUDENT_DEL, OnUpdateCommandDel)
	ON_UPDATE_COMMAND_UI(ID_STUDENT_NEXT, OnUpdateCommandEnd)
	ON_UPDATE_COMMAND_UI(ID_STUDENT_PREV, OnUpdateCommandHome)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CStudentView Konstruktion/Destruktion

CStudentView::CStudentView()
	: CFormView(CStudentView::IDD)
{
	TRACE("Eintritt in den Konstruktor von CStudentView\n");
	//{{AFX_DATA_INIT(CStudentView)
	m_nGrade = 0;
	m_strName = _T("");
	//}}AFX_DATA_INIT
	m_position = NULL;}

CStudentView::~CStudentView()
{
}

void CStudentView::DoDataExchange(CDataExchange* pDX)
{
	CFormView::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CStudentView)
	DDX_Text(pDX, IDC_GRADE, m_nGrade);
	DDV_MinMaxInt(pDX, m_nGrade, 0, 100);
	DDX_Text(pDX, IDC_NAME, m_strName);
	DDV_MaxChars(pDX, m_strName, 20);
	//}}AFX_DATA_MAP
}

BOOL CStudentView::PreCreateWindow(CREATESTRUCT& cs)
{
	// ZU ERLEDIGEN: ndern Sie hier die Fensterklasse oder das Erscheinungsbild, indem Sie
	//  CREATESTRUCT cs modifizieren.

	return CFormView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CStudentView Diagnose

#ifdef _DEBUG
void CStudentView::AssertValid() const
{
	CFormView::AssertValid();
}

void CStudentView::Dump(CDumpContext& dc) const
{
	CFormView::Dump(dc);
}

CStudentDoc* CStudentView::GetDocument() // Die endgltige (nicht zur Fehlersuche kompilierte) Version ist Inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CStudentDoc)));
	return (CStudentDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CStudentView Nachrichten-Handler

void CStudentView::OnClear() 
{
	TRACE("Eintritt in CStudentView::OnClear\n");
	ClearEntry();
}

void CStudentView::OnUpdate(CView* pSender, LPARAM lHint, CObject* pHint) 
{
	// wird von OnInitialUpdate und UpdateAllViews aufgerufen
	TRACE("Eintritt in CStudentView::OnUpdate\n");
	m_position = m_pList->GetHeadPosition();
	GetEntry(m_position); // die ersten Daten fr die Ansicht
}

void CStudentView::OnInitialUpdate() 
{
	TRACE("Eintritt in CStudentView::OnInitialUpdate\n");
	m_pList = GetDocument()->GetList();
	CFormView::OnInitialUpdate();
}

void CStudentView::OnCommandHome() 
{
	TRACE("Eintritt in CStudentView::OnCommandHome\n");
	// leere Liste mu behandelt werden
	if (!m_pList->IsEmpty()) {
		m_position = m_pList->GetHeadPosition();
		GetEntry(m_position);
	}
}

void CStudentView::OnCommandEnd() 
{
	TRACE("Eintritt in CStudentView::OnCommandEnd\n");
	if (!m_pList->IsEmpty()) {
		m_position = m_pList->GetTailPosition();
		GetEntry(m_position);
	}
}

void CStudentView::OnCommandPrev() 
{
	POSITION pos;
	TRACE("Eintritt in CStudentView::OnCommandPrev\n");
	if ((pos = m_position) != NULL) {
		m_pList->GetPrev(pos);
		if (pos) {
			GetEntry(pos);
			m_position = pos;
		}
	}
}

void CStudentView::OnCommandNext() 
{
	POSITION pos;
	TRACE("Eintritt in CStudentView::OnCommandNext\n");
	if ((pos = m_position) != NULL) {
		m_pList->GetNext(pos);
		if (pos) {
			GetEntry(pos);
			m_position = pos;
		}
	}
}

void CStudentView::OnCommandIns() 
{
	TRACE("Eintritt in CStudentView::OnCommandIns\n");
	InsertEntry(m_position);
	GetDocument()->SetModifiedFlag();
	GetDocument()->UpdateAllViews(this);
}

void CStudentView::OnCommandDel() 
{
	// lscht aktuellen Eintrag und positioniert auf den nchsten oder ersten
	POSITION pos;
	TRACE("Eintritt in CStudentView::OnCommandDel\n");
	if ((pos = m_position) != NULL) {
		m_pList->GetNext(pos);
		if (pos == NULL) {
			pos = m_pList->GetHeadPosition();
			TRACE("GetHeadPos = %ld\n", pos);
			if (pos == m_position) {
				pos = NULL;
			}
		}
		GetEntry(pos);
		CStudent* ps = m_pList->GetAt(m_position);
		m_pList->RemoveAt(m_position);
		delete ps;
		m_position = pos;
		GetDocument()->SetModifiedFlag();
		GetDocument()->UpdateAllViews(this);
	}
}

void CStudentView::OnUpdateCommandHome(CCmdUI* pCmdUI) 
{
	// wird in der Leerlaufschleife und beim ffnen des Mens "Student" aufgerufen
	POSITION pos;

	// aktiviert die Schaltflche, wenn die Liste nicht leer ist und 
	// nicht bereits am Anfang steht
	pos = m_pList->GetHeadPosition();
	pCmdUI->Enable((m_position != NULL) && (pos != m_position));
}

void CStudentView::OnUpdateCommandEnd(CCmdUI* pCmdUI) 
{
	// wird in der Leerlaufschleife und beim ffnen des Mens "Student" aufgerufen
	POSITION pos;

	// aktiviert die Schaltflche, wenn die Liste nicht leer ist und 
	// nicht bereits am Ende steht
	pos = m_pList->GetTailPosition();
	pCmdUI->Enable((m_position != NULL) && (pos != m_position));
}


void CStudentView::OnUpdateCommandDel(CCmdUI* pCmdUI) 
{
	// wird in der Leerlaufschleife und beim ffnen des Mens "Student" aufgerufen
	pCmdUI->Enable(m_position != NULL);
}

void CStudentView::GetEntry(POSITION position)
{
	if (position) {
		CStudent* pStudent = m_pList->GetAt(position);
		m_strName = pStudent->m_strName;
		m_nGrade = pStudent->m_nGrade;
	}
	else {
		ClearEntry();
	}
	UpdateData(FALSE);
}

void CStudentView::InsertEntry(POSITION position)
{
	if (UpdateData(TRUE)) {
		// UpdateData gibt bei Fehler FALSE zurck
		CStudent* pStudent = new CStudent;
		pStudent->m_strName = m_strName;
		pStudent->m_nGrade = m_nGrade;
		m_position = m_pList->InsertAfter(m_position, pStudent);
	}
}

void CStudentView::ClearEntry()
{
	m_strName = "";
	m_nGrade = 0;
	UpdateData(FALSE);
	((CDialog*) this)->GotoDlgCtrl(GetDlgItem(IDC_NAME));
}
