// LogScrollView.h : Schnittstelle der Klasse CLogScrollView
//
/////////////////////////////////////////////////////////////////////////////
#ifndef _LOG_TWIPS_SCROLL_VIEW 
#define _LOG_TWIPS_SCROLL_VIEW 

#define CX_BORDER   1
#define CY_BORDER   1

class CLogScrollView : public CView
{
	DECLARE_DYNAMIC(CLogScrollView)

// Constructors
protected:
	CLogScrollView();

public:
	void SetLogScrollSizes(SIZE sizeTotal); // in logischen Einheiten

// Attributes
public:
	CPoint GetScrollPosition() const;       // obere Ecke des Bildlaufs
	CSize GetTotalSize() const;             // logische Gre

	// for device units
	CPoint GetDeviceScrollPosition() const;

// Operations
public:
	void ScrollToPosition(POINT pt);    // Position der oberen linken Ecke festlegen 
	void FillOutsideRect(CDC* pDC, CBrush* pBrush);
	void ResizeParentToFit(BOOL bShrinkOnly = TRUE);

// Implementation
protected:
	CSize m_totalLog;           // Gesamtgre in logischen Einheiten (nicht gerundet)
	CSize m_totalDev;           // Gesamtgre in Gerteeinheiten
	CSize m_pageDev;            // Seitengre pro Bildlauf in Gerteeinheiten
	CSize m_lineDev;            // Zeilenhhe pro Bildlauf in Gerteeinheiten

	BOOL m_bCenter;             // Ausgabe zentrieren, falls grer als Gesamtgre 
	BOOL m_bInsideUpdate;       // interner Status fr OnSize-Callback
	void CenterOnPoint(CPoint ptCenter);
	void ScrollToDevicePosition(POINT ptDev); // expliziter Bildlauf, keine Prfung

protected:
	virtual void OnDraw(CDC* pDC) = 0;      // rein virtuelle Funktion weitergeben

	void UpdateBars();          // Bildlaufleisten etc. aktualisieren
	BOOL GetTrueClientSize(CSize& size, CSize& sizeSb);
		// Gre ohne Bildlaufleisten
	void GetScrollBarSizes(CSize& sizeSb);
	void GetScrollBarState(CSize sizeClient, CSize& needSb,
		CSize& sizeRange, CPoint& ptMove, BOOL bInsideClient);

public:
	virtual ~CLogScrollView();
#ifdef _DEBUG
	virtual void Dump(CDumpContext&) const;
#endif //_DEBUG
	virtual void CalcWindowRect(LPRECT lpClientRect,
		UINT nAdjustType = adjustBorder);
	virtual void OnPrepareDC(CDC* pDC, CPrintInfo* pInfo = NULL);

	// Untersttzung fr OLE-Bildlaufimplementierung
	virtual BOOL OnScroll(UINT nScrollCode, UINT nPos, BOOL bDoScroll = TRUE);
	virtual BOOL OnScrollBy(CSize sizeScroll, BOOL bDoScroll = TRUE);

	//{{AFX_MSG(CLogScrollView)
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
	afx_msg void OnVScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};
#endif _LOG_TWIPS_SCROLL_VIEW 

