// HexView.cpp : Implementierung der Klasse CHexView
//

#include "stdafx.h"
#include "ex21b.h"

#include "PoemDoc.h"
#include "HexView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CHexView

IMPLEMENT_DYNCREATE(CHexView, CScrollView)

BEGIN_MESSAGE_MAP(CHexView, CScrollView)
	//{{AFX_MSG_MAP(CHexView)
	// HINWEIS - Hier werden Mapping-Makros vom Klassen-Assistenten eingefgt und entfernt.
	//    Innerhalb dieser generierten Quelltextabschnitte NICHTS VERNDERN!
	//}}AFX_MSG_MAP
	// Standard-Druckbefehle
	ON_COMMAND(ID_FILE_PRINT, CScrollView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, CScrollView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CScrollView::OnFilePrintPreview)
	ON_MESSAGE(WM_COMMANDHELP, OnCommandHelp)
	ON_MESSAGE(WM_HELPHITTEST, OnHelpHitTest)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CHexView Konstruktion//Destruktion

CHexView::CHexView() : m_rectPrint(0, 0, 11520, -15120)
{
	// ZU ERLEDIGEN: Hier Code zur Konstruktion einfgen,
}

CHexView::~CHexView()
{
}

BOOL CHexView::PreCreateWindow(CREATESTRUCT& cs)
{
	// ZU ERLEDIGEN: ndern Sie hier die Fensterklasse oder das Erscheinungsbild, indem Sie
	//  CREATESTRUCT cs modifizieren.

	return CScrollView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CHexView Zeichnen

void CHexView::OnDraw(CDC* pDC)
{
	// Hexadezimaldarstellung von Dokument-Zeichenfolgen
	int        i, j, k, l, n, nHeight;
	CString    outputLine, str;
	CFont      font;
	TEXTMETRIC tm;

	CPoemDoc* pDoc = GetDocument();
	font.CreateFont(-160, 80, 0, 0, 400, FALSE, FALSE, 0,
		ANSI_CHARSET, OUT_DEFAULT_PRECIS, CLIP_DEFAULT_PRECIS,
		DEFAULT_QUALITY, DEFAULT_PITCH | FF_SWISS, "Arial");
	CFont* pOldFont = pDC->SelectObject(&font);
	pDC->GetTextMetrics(&tm);
	nHeight = tm.tmHeight + tm.tmExternalLeading;
    TRACE("Schrifthhe = %d, InternalLeading = %d\n",
          nHeight, tm.tmInternalLeading);
	j = pDoc->m_stringArray.GetSize();
	for (i = 0; i < j; i++) {
		outputLine.Format("%02x   ", i);
		l = pDoc->m_stringArray[i].GetLength();
		for (k = 0; k < l; k++) {
			n = pDoc->m_stringArray[i][k] & 0x00ff;
			str.Format("%02x ", n);
			outputLine += str;
		}
		pDC->TextOut(720, -i * nHeight - 720, outputLine);
	}
	pDC->SelectObject(pOldFont);
    TRACE("LOGPIXELSX = %d, LOGPIXELSY = %d\n",
          pDC->GetDeviceCaps(LOGPIXELSX),
          pDC->GetDeviceCaps(LOGPIXELSY));
    TRACE("HORZSIZE = %d, VERTSIZE = %d\n",
          pDC->GetDeviceCaps(HORZSIZE),
          pDC->GetDeviceCaps(VERTSIZE));
}

void CHexView::OnInitialUpdate()
{
	CScrollView::OnInitialUpdate();
    CSize sizeTotal(m_rectPrint.Width(), -m_rectPrint.Height());
    CSize sizePage(sizeTotal.cx / 2,
                   sizeTotal.cy / 2);   // Seitenweise blttern
    CSize sizeLine(sizeTotal.cx / 100,
                   sizeTotal.cy / 100); // Zeilenweise blttern
    SetScrollSizes(MM_TWIPS, sizeTotal, sizePage, sizeLine);
}


/////////////////////////////////////////////////////////////////////////////
// CHexView Drucken

BOOL CHexView::OnPreparePrinting(CPrintInfo* pInfo)
{
	pInfo->SetMaxPage(1);
	return DoPreparePrinting(pInfo);
}

void CHexView::OnBeginPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{

}

void CHexView::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{

}

/////////////////////////////////////////////////////////////////////////////
// CHexView Diagnose

#ifdef _DEBUG
void CHexView::AssertValid() const
{
	CScrollView::AssertValid();
}

void CHexView::Dump(CDumpContext& dc) const
{
	CScrollView::Dump(dc);
}

CPoemDoc* CHexView::GetDocument() 
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CPoemDoc)));
	return (CPoemDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CHexView Nachrichtenbehandlung

void CHexView::OnPrint(CDC* pDC, CPrintInfo* pInfo) 
{
	CScrollView::OnPrint(pDC, pInfo);
}

LRESULT CHexView::OnCommandHelp(WPARAM wParam, LPARAM lParam)
{
	if (lParam == 0) { // Kontext wurde noch nicht bestimmt
		lParam = HID_BASE_RESOURCE + IDR_HEXVIEW;
	}
	AfxGetApp()->WinHelp(lParam);
	return TRUE;
}

LRESULT CHexView::OnHelpHitTest(WPARAM wParam, LPARAM lParam)
{
	return HID_BASE_RESOURCE + IDR_HEXVIEW;
}

