// MainFrm.cpp : Implementierung der Klasse CMainFrame
//

#include "stdafx.h"
#include "ex26b.h"

#include "MainFrm.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMainFrame

IMPLEMENT_DYNAMIC(CMainFrame, CMDIFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CMDIFrameWnd)
	//{{AFX_MSG_MAP(CMainFrame)
	ON_WM_CREATE()
	ON_WM_PALETTECHANGED()
	ON_WM_QUERYNEWPALETTE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

static UINT indicators[] =
{
	ID_SEPARATOR,           // Statusleistenanzeige
	ID_INDICATOR_CAPS,
	ID_INDICATOR_NUM,
	ID_INDICATOR_SCRL,
};

/////////////////////////////////////////////////////////////////////////////
// CMainFrame Konstruktion/Zerstrung

CMainFrame::CMainFrame()
{
	// ZU ERLEDIGEN: Hier Code zur Member-Initialisierung einfgen
	
}

CMainFrame::~CMainFrame()
{
}

int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CMDIFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	if (!m_wndToolBar.CreateEx(this, TBSTYLE_FLAT, WS_CHILD | WS_VISIBLE | CBRS_TOP
		| CBRS_GRIPPER | CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_DYNAMIC) ||
		!m_wndToolBar.LoadToolBar(IDR_MAINFRAME))
	{
		TRACE0("Symbolleiste konnte nicht erstellt werden\n");
		return -1;      // Fehler bei Erstellung
	}

	if (!m_wndStatusBar.Create(this) ||
		!m_wndStatusBar.SetIndicators(indicators,
		  sizeof(indicators)/sizeof(UINT)))
	{
		TRACE0("Statusleiste konnte nicht erstellt werden\n");
		return -1;      // Fehler bei Erstellung
	}

	// ZU ERLEDIGEN: Lschen Sie diese drei Zeilen, wenn Sie nicht wollen, dass die Symbolleiste
	//  andockbar ist.
	m_wndToolBar.EnableDocking(CBRS_ALIGN_ANY);
	EnableDocking(CBRS_ALIGN_ANY);
	DockControlBar(&m_wndToolBar);

	return 0;
}

BOOL CMainFrame::PreCreateWindow(CREATESTRUCT& cs)
{
	if( !CMDIFrameWnd::PreCreateWindow(cs) )
		return FALSE;
	// ZU ERLEDIGEN: ndern Sie hier die Fensterklasse oder das Erscheinungsbild, indem Sie
	//  CREATESTRUCT cs modifizieren.

	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// CMainFrame Diagnose

#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
	CMDIFrameWnd::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const
{
	CMDIFrameWnd::Dump(dc);
}

#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CMainFrame Nachrichten-Handler


void CMainFrame::OnPaletteChanged(CWnd* pFocusWnd) 
{
	TRACE("CMainFrame::OnPaletteChanged\n");
	if(GetSafeHwnd() != pFocusWnd->GetSafeHwnd()) {
		OnQueryNewPalette();
	}
}

BOOL CMainFrame::OnQueryNewPalette() 
{
	TRACE("CMainFrame::OnQueryNewPalette\n");
	CClientDC dc(this);
	// Wir verwenden keine Palette
	if((dc.GetDeviceCaps(RASTERCAPS) & RC_PALETTE) == 0) return TRUE;
	// Aktuelle Ansicht ermitteln
	HWND hActiveView = NULL;
	CFrameWnd* pActiveFrm = GetActiveFrame();
	if(pActiveFrm != NULL) {
		CView* pActiveView = pActiveFrm->GetActiveView();
		if(pActiveView != NULL) {
			hActiveView = pActiveView->GetSafeHwnd();
		}
	}
	// Alle Ansichten bearbeiten
	BOOL bBackground;
	CView* pView;
	CDocument* pDoc;
	CDocTemplate* pTemplate;
	POSITION posView;
	POSITION posDoc;
	POSITION posTemplate = AfxGetApp()->GetFirstDocTemplatePosition();
	while(posTemplate != NULL) {
		pTemplate = AfxGetApp()->GetNextDocTemplate(posTemplate);
		posDoc = pTemplate->GetFirstDocPosition();
		while(posDoc != NULL) {
			pDoc = pTemplate->GetNextDoc(posDoc);
			posView = pDoc->GetFirstViewPosition();
			while(posView != NULL) {
				pView = pDoc->GetNextView(posView);
				bBackground = !(hActiveView == pView->GetSafeHwnd());
				// Falls Ansicht nicht aktuelle Ansicht ist, Hintergrundmodus einsetzen
				pView->SendMessage(WM_VIEWPALETTECHANGED, bBackground);
			}
		}

	}
	
/*	
	
*/
	return TRUE;	
}
