// ex28bDoc.cpp : Implementierung der Klasse CEx28bDoc
//

#include "stdafx.h"
#include "ex28b.h"

#include "ex28bDoc.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

const OLECHAR* CEx28bDoc::s_szSub = L"sub";   // statisch      

/////////////////////////////////////////////////////////////////////////////
// CEx28bDoc

IMPLEMENT_DYNCREATE(CEx28bDoc, CDocument)

BEGIN_MESSAGE_MAP(CEx28bDoc, CDocument)
	//{{AFX_MSG_MAP(CEx28bDoc)
	ON_COMMAND(ID_EDIT_CLEAR_ALL, OnEditClearAll)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

BEGIN_INTERFACE_MAP(CEx28bDoc, CDocument)
	INTERFACE_PART(CEx28bDoc, IID_IOleClientSite, OleClientSite)
	INTERFACE_PART(CEx28bDoc, IID_IAdviseSink, AdviseSink)
END_INTERFACE_MAP()

/////////////////////////////////////////////////////////////////////////////
// Implementierung von IOleClientSite

STDMETHODIMP_(ULONG) CEx28bDoc::XOleClientSite::AddRef()
{
	TRACE("CEx28bDoc::XOleClientSite::AddRef\n");
	METHOD_PROLOGUE(CEx28bDoc, OleClientSite)
	return pThis->InternalAddRef();
}

STDMETHODIMP_(ULONG) CEx28bDoc::XOleClientSite::Release()
{
	TRACE("CEx28bDoc::XOleClientSite::Release\n");
	METHOD_PROLOGUE(CEx28bDoc, OleClientSite)
	return pThis->InternalRelease();
}

STDMETHODIMP CEx28bDoc::XOleClientSite::QueryInterface(
	REFIID iid, LPVOID* ppvObj)
{
	ITrace(iid, "CEx28bDoc::XOleClientSite::QueryInterface");
	METHOD_PROLOGUE(CEx28bDoc, OleClientSite)
	return pThis->InternalQueryInterface(&iid, ppvObj);
}

STDMETHODIMP CEx28bDoc::XOleClientSite::SaveObject()
{
	TRACE("CEx28bDoc::XOleClientSite::SaveObject\n");
	METHOD_PROLOGUE(CEx28bDoc, OleClientSite)
	ASSERT_VALID(pThis);

	LPPERSISTSTORAGE lpPersistStorage;
	pThis->m_lpOleObj->QueryInterface(IID_IPersistStorage, 
		(void**) &lpPersistStorage);
	ASSERT(lpPersistStorage != NULL);
	HRESULT hr = NOERROR;
	if (lpPersistStorage->IsDirty() == NOERROR)
	{
		// NOERROR == S_OK != S_FALSE, Objekt wurde also gendert!
		hr = ::OleSave(lpPersistStorage, pThis->m_pTempStgSub, TRUE);
		if (hr != NOERROR)
			hr = lpPersistStorage->SaveCompleted(NULL);

		// Dokument als gendert markieren, falls Objekt gespeichert wurde
		pThis->SetModifiedFlag();
	}
	lpPersistStorage->Release();
	pThis->UpdateAllViews(NULL);
	return hr;
}

STDMETHODIMP CEx28bDoc::XOleClientSite::GetMoniker(
	DWORD dwAssign, DWORD dwWhichMoniker, LPMONIKER* ppMoniker)
{
	TRACE("CEx28bDoc::XOleClientSite::GetMoniker\n");
	return E_NOTIMPL;
}

STDMETHODIMP CEx28bDoc::XOleClientSite::GetContainer(
	LPOLECONTAINER* ppContainer)
{
	TRACE("CEx28bDoc::XOleClientSite::GetContainer\n");
	return E_NOTIMPL;
}

STDMETHODIMP CEx28bDoc::XOleClientSite::ShowObject()
{
	TRACE("CEx28bDoc::XOleClientSite::ShowObject\n");
	METHOD_PROLOGUE(CEx28bDoc, OleClientSite)
	ASSERT_VALID(pThis);
	pThis->UpdateAllViews(NULL);
	return NOERROR;
}

STDMETHODIMP CEx28bDoc::XOleClientSite::OnShowWindow(BOOL fShow)
{
	TRACE("CEx28bDoc::XOleClientSite::OnShowWindow\n");
	METHOD_PROLOGUE(CEx28bDoc, OleClientSite)
	ASSERT_VALID(pThis);
	pThis->m_bHatch = fShow;
	pThis->UpdateAllViews(NULL);
	return NOERROR;
}

STDMETHODIMP CEx28bDoc::XOleClientSite::RequestNewObjectLayout()
{
	TRACE("CEx28bDoc::XOleClientSite::RequestNewObjectLayout\n");
	return E_NOTIMPL;
}

/////////////////////////////////////////////////////////////////////////////
// Implementierung von IAdviseSink

STDMETHODIMP_(ULONG) CEx28bDoc::XAdviseSink::AddRef()
{
	TRACE("CEx28bDoc::XAdviseSink::AddRef\n");
	METHOD_PROLOGUE(CEx28bDoc, AdviseSink)
	return pThis->InternalAddRef();
}

STDMETHODIMP_(ULONG) CEx28bDoc::XAdviseSink::Release()
{
	TRACE("CEx28bDoc::XAdviseSink::Release\n");
	METHOD_PROLOGUE(CEx28bDoc, AdviseSink)
	return pThis->InternalRelease();
}

STDMETHODIMP CEx28bDoc::XAdviseSink::QueryInterface(
	REFIID iid, LPVOID* ppvObj)
{
	ITrace(iid, "CEx28bDoc::XAdviseSink::QueryInterface");
	METHOD_PROLOGUE(CEx28bDoc, AdviseSink)
	return pThis->InternalQueryInterface(&iid, ppvObj);
}

STDMETHODIMP_(void) CEx28bDoc::XAdviseSink::OnDataChange(
	LPFORMATETC lpFormatEtc, LPSTGMEDIUM lpStgMedium)
{
	TRACE("CEx28bDoc::XAdviseSink::OnDataChange\n");
	METHOD_PROLOGUE(CEx28bDoc, AdviseSink)
	ASSERT_VALID(pThis);

	// Nur fr Container interessant. So weitergeben, dass
	// Container nicht die gesamte Schnittstelle implementieren mssen.
}

STDMETHODIMP_(void) CEx28bDoc::XAdviseSink::OnViewChange(
	DWORD aspects, LONG /*lindex*/)
{
	TRACE("CEx28bDoc::XAdviseSink::OnViewChange\n");
	METHOD_PROLOGUE(CEx28bDoc, AdviseSink)
	ASSERT_VALID(pThis);

	pThis->UpdateAllViews(NULL);	// wirklich wichtig
}

STDMETHODIMP_(void) CEx28bDoc::XAdviseSink::OnRename(
	LPMONIKER /*lpMoniker*/)
{
	TRACE("CEx28bDoc::XAdviseSink::OnRename\n");
	// Nur fr das OLE-Linkobjekt interessant. Container ignorieren diesen Aufruf
}

STDMETHODIMP_(void) CEx28bDoc::XAdviseSink::OnSave()
{
	TRACE("CEx28bDoc::XAdviseSink::OnSave\n");
	METHOD_PROLOGUE(CEx28bDoc, AdviseSink)
	ASSERT_VALID(pThis);

	pThis->UpdateAllViews(NULL);
}

STDMETHODIMP_(void) CEx28bDoc::XAdviseSink::OnClose()
{
	TRACE("CEx28bDoc::XAdviseSink::OnClose\n");
	METHOD_PROLOGUE(CEx28bDoc, AdviseSink)
	ASSERT_VALID(pThis);

	pThis->UpdateAllViews(NULL);
}

/////////////////////////////////////////////////////////////////////////////
// CEx28bDoc Konstruktion/Destruktion

CEx28bDoc::CEx28bDoc()
{
	m_lpOleObj = NULL;
	m_pTempStgRoot = NULL;
	m_pTempStgSub = NULL;
	m_bHatch = FALSE;
}

CEx28bDoc::~CEx28bDoc()
{
}

BOOL CEx28bDoc::OnNewDocument()
{
	TRACE("Eintritt CEx28bDoc::OnNewDocument\n");
	// Sturkturierte Ablage fr das Objekt anlegen (m_pTempStgSub)
	// Dies ist eine temporre Date, deren Name von OLE willkrlich gewhlt wird.
	VERIFY(::StgCreateDocfile(NULL,
		STGM_READWRITE|STGM_SHARE_EXCLUSIVE|STGM_CREATE|
		STGM_DELETEONRELEASE,
		0, &m_pTempStgRoot) == S_OK);
	ASSERT(m_pTempStgRoot!= NULL);
	
    VERIFY(m_pTempStgRoot->CreateStorage(OLESTR("sub"),
    	   STGM_CREATE|STGM_READWRITE|STGM_SHARE_EXCLUSIVE,
    	   0, 0, &m_pTempStgSub) == S_OK);
	ASSERT(m_pTempStgSub != NULL);
	return CDocument::OnNewDocument();
}



/////////////////////////////////////////////////////////////////////////////
// CEx28bDoc Serialisierung

void CEx28bDoc::Serialize(CArchive& ar)
{
	if (ar.IsStoring())
	{
		// ZU ERLEDIGEN: Hier Code zum Speichern einfgen
	}
	else
	{
		// ZU ERLEDIGEN: Hier Code zum Laden einfgen
	}
}

/////////////////////////////////////////////////////////////////////////////
// CEx28bDoc Diagnose

#ifdef _DEBUG
void CEx28bDoc::AssertValid() const
{
	CDocument::AssertValid();
}

void CEx28bDoc::Dump(CDumpContext& dc) const
{
	CDocument::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CEx28bDoc Befehle

void CEx28bDoc::OnCloseDocument() 
{
	m_pTempStgSub->Release(); // Muss vor dem Aufruf der Basisklasse freigegeben werden
	m_pTempStgRoot->Release();
	CDocument::OnCloseDocument();
}

void CEx28bDoc::DeleteContents() 
{
	if(m_lpOleObj != NULL) {
	   // Falls Objekt ausgefhrt wird, muss es geschlossen werden,
	   // womit auch IOleClientSite geschlossen wird
		m_lpOleObj->Close(OLECLOSE_NOSAVE);
		m_lpOleObj->Release(); // muss letzter Release-Aufruf sein
		m_lpOleObj = NULL;
	}
}

void CEx28bDoc::OnEditClearAll() 
{
    DeleteContents();
    UpdateAllViews(NULL);
    SetModifiedFlag();
	m_bHatch = FALSE;
}

BOOL CEx28bDoc::SaveModified() 
{
	// Speichern-Meldung unterdrcken
	return TRUE;
}

void ITrace(REFIID iid, const char* str)
{
	OLECHAR* lpszIID;
	::StringFromIID(iid, &lpszIID);
	CString strIID = lpszIID;
	TRACE("%s - %s\n", (const char*) strIID, (const char*) str);
	AfxFreeTaskMem(lpszIID);
}

