// ex31cView.cpp : Implementierung der Klasse CEx31cView
//

#include "stdafx.h"
#include "ex31c.h"

#include "ex31cSet.h"
#include "SectionSet.h"
#include "ex31cDoc.h"
#include "ex31cView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CEx31cView

IMPLEMENT_DYNCREATE(CEx31cView, CRecordView)

BEGIN_MESSAGE_MAP(CEx31cView, CRecordView)
	//{{AFX_MSG_MAP(CEx31cView)
	ON_COMMAND(ID_RECORD_ADD, OnRecordAdd)
	ON_COMMAND(ID_RECORD_CLEARFIELDS, OnRecordClearfields)
	ON_COMMAND(ID_RECORD_DELETE, OnRecordDelete)
	ON_UPDATE_COMMAND_UI(ID_RECORD_DELETE, OnUpdateRecordDelete)
	ON_COMMAND(ID_RECORD_UPDATE, OnRecordUpdate)
	ON_UPDATE_COMMAND_UI(ID_RECORD_UPDATE, OnUpdateRecordUpdate)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CEx31cView Konstruktion/Destruktion

CEx31cView::CEx31cView()
	: CRecordView(CEx31cView::IDD)
{
	//{{AFX_DATA_INIT(CEx31cView)
	m_pSet = NULL;
	//}}AFX_DATA_INIT
	// ZU ERLEDIGEN: Hier Code zur Konstruktion einfgen,

}

CEx31cView::~CEx31cView()
{
}

void CEx31cView::DoDataExchange(CDataExchange* pDX)
{
	CRecordView::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CEx31cView)
	DDX_FieldText(pDX, IDC_ID, m_pSet->m_InstructorID, m_pSet);
	DDX_FieldText(pDX, IDC_NAME, m_pSet->m_Name, m_pSet);
	DDX_FieldText(pDX, IDC_ROOM, m_pSet->m_RoomNo, m_pSet);
	//}}AFX_DATA_MAP
}

BOOL CEx31cView::PreCreateWindow(CREATESTRUCT& cs)
{
	// ZU ERLEDIGEN: ndern Sie hier die Fensterklasse oder das Erscheinungsbild, indem Sie
	//  CREATESTRUCT cs modifizieren.

	return CRecordView::PreCreateWindow(cs);
}

void CEx31cView::OnInitialUpdate()
{
	m_pSet = GetDocument()->m_pEx31cSet;
	CRecordView::OnInitialUpdate();
	LoadListbox();

}

/////////////////////////////////////////////////////////////////////////////
// CEx31cView Diagnose

#ifdef _DEBUG
void CEx31cView::AssertValid() const
{
	CRecordView::AssertValid();
}

void CEx31cView::Dump(CDumpContext& dc) const
{
	CRecordView::Dump(dc);
}

CEx31cDoc* CEx31cView::GetDocument() // Die endgltige (nicht zur Fehlersuche kompilierte) Version ist Inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CEx31cDoc)));
	return (CEx31cDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CEx31cView Datenbankuntersttzung
CRecordset* CEx31cView::OnGetRecordset()
{
	return m_pSet;
}


void CEx31cView::LoadListbox()
{
	CEx31cDoc* pDoc = GetDocument();
	CListBox* pLB = (CListBox*) GetDlgItem(IDC_SECTIONS);
	CSectionSet sect(&pDoc->m_database);  // // db wird vom Konstruktor bergeben

	sect.m_strFilter.Format("InstructorID = '%s'", 
		(LPCSTR) m_pSet->m_InstructorID);

	sect.m_strFilter="InstructorID=?";
	sect.m_InstructorIDParam=m_pSet->m_InstructorID;

	sect.Open();
	pLB->ResetContent();
	while(!sect.IsEOF()) {
		pLB->AddString(sect.m_CourseID + " " + sect.m_SectionNo);
		sect.MoveNext();
	}
	// sect wird vom CRecordset-Destruktor geschlossen
}
/////////////////////////////////////////////////////////////////////////////
// CEx31cView Nachrichten-Handler

BOOL CEx31cView::OnMove(UINT nIDMoveCommand) 
{
	switch (nIDMoveCommand)
	{
		case ID_RECORD_PREV:
			m_pSet->MovePrev();
			if (!m_pSet->IsBOF())
				break;

		case ID_RECORD_FIRST:
			m_pSet->MoveFirst();
			break;

		case ID_RECORD_NEXT:
			m_pSet->MoveNext();
			if (!m_pSet->IsEOF())
				break;
			if (!m_pSet->CanScroll()) {
				// Bildschirm lschen, da Dateiende erreicht
				m_pSet->SetFieldNull(NULL);
				break;
			}

		case ID_RECORD_LAST:
			m_pSet->MoveLast();
			break;

		default:
			// Unerwarteter Wert
			ASSERT(FALSE);
	}
	// Ergebnisse zeigen
	UpdateData(FALSE);
	LoadListbox();
	return TRUE;
}

void CEx31cView::OnRecordAdd() 
{
	m_pSet->AddNew();
	UpdateData(TRUE);
	if (m_pSet->CanUpdate())
	{
		m_pSet->Update();
	}
	if(!m_pSet->IsEOF()) {
		m_pSet->MoveLast();
	}
//	m_pSet->Requery(); // fr sortierte Recordsets
	UpdateData(FALSE);
	LoadListbox();
}

void CEx31cView::OnRecordClearfields() 
{
	m_pSet->m_InstructorID = _T("");
	m_pSet->m_Name = _T("");
	m_pSet->m_RoomNo = _T("");
	UpdateData(FALSE);
	LoadListbox();
//	CListBox* pLB = (CListBox*) GetDlgItem(IDC_SECTIONS);
//	pLB->ResetContent();
}

void CEx31cView::OnRecordDelete() 
{
	try {
		m_pSet->Delete();
	}
	catch(CDBException* e) {
		AfxMessageBox(e->m_strError);
		e->Delete();
		m_pSet->MoveFirst(); // Posiiton verloren!
		UpdateData(FALSE);
		return;
	}
    m_pSet->MoveNext();
    // Zurck zum letzten, falls Dateiende erreicht
    if (m_pSet->IsEOF()) {
      m_pSet->MoveLast();
    }
    // Ist die Satzgruppe jetzt leer?
    if (m_pSet->IsEOF()) {
      m_pSet->SetFieldNull(NULL);
    }
    UpdateData(FALSE);
	LoadListbox();
}

void CEx31cView::OnUpdateRecordDelete(CCmdUI* pCmdUI) 
{
    pCmdUI->Enable(!m_pSet->IsEOF());
}

void CEx31cView::OnRecordUpdate() 
{
	m_pSet->Edit();
	UpdateData(TRUE);
	if (m_pSet->CanUpdate()) {
		m_pSet->Update();
	}
	LoadListbox();
// Nur Snapshots  : erneute Abfrage, falls Schlsselfeldwert verndert
}

void CEx31cView::OnUpdateRecordUpdate(CCmdUI* pCmdUI) 
{
    pCmdUI->Enable(!m_pSet->IsEOF());
}
