// rowview.h : Schnittstelle der Klasse CRowView
//
// Diese Klasse implementiert das Verhalten einer bildlauffhigen Ansicht,
// die mehrere Zeilen von Daten fester Hhe anzeigt. Diese Ansicht hnelt
// einem Listenfeld, das vom bergeordneten Fenster gezeichnet wird.
// Im Unterschied zu Listenfeldern weist diese Ansicht aber alle Vorzge
// einer (bildlauffhigen) Ansicht auf, wie z.B. Druck- und Seitenansichtsfunktionen.
/////////////////////////////////////////////////////////////////////////////

class CRowView : public CScrollView 
{
DECLARE_DYNAMIC(CRowView)
protected:
// Konstruktion/Destruktion
    CRowView();
    virtual ~CRowView();
// Attribute
protected:
    int m_nRowWidth;            // Zeilenbreite in logischen Einheiten
    int m_nRowHeight;           // Zeilenhhe in logischen Einheiten
    int m_nCharWidth;           // durchschnittliche Zeichenbreite in logischen Einheiten
    int m_nPrevSelectedRow;     // Index der zuletzt ausgewhlten Zeile
    int m_nPrevRowCount;        // letzte Zeilenzahl,vor Aktualisierung
    int m_nRowsPerPrintedPage;  // Zeilenzahl einer gedruckten Seite

// Operationen-Attribute
protected:
    virtual void UpdateRow(int nInvalidRow); // wird von der abgeleiteten Klasse
	                                         // aufgerufen
    virtual void CalculateRowMetrics(CDC* pDC)
            { GetRowWidthHeight(pDC, m_nRowWidth, m_nRowHeight, 
			    m_nCharWidth); }
    virtual void UpdateScrollSizes();
    virtual CRect RowToWndRect(CDC* pDC, int nRow);
    virtual int RowToYPos(int nRow);
    virtual void RectLPtoRowRange(const CRect& rectLP, int& nFirstRow,
        int& nLastRow, BOOL bIncludePartiallyShownRows);
    virtual int LastViewableRow();

// berschreibungen
protected:
    virtual void GetRowWidthHeight(CDC* pDC, int& nRowWidth, 
        int& nRowHeight, int& nCharWidth) = 0;
    virtual int GetActiveRow() = 0;
    virtual int GetRowCount() = 0;
    virtual void OnDrawRow(CDC* pDC, int nRow, int y, BOOL bSelected) = 0;
    virtual void ChangeSelectionNextRow(BOOL bNext) = 0;
    virtual void ChangeSelectionToRow(int nRow) = 0;

// Implementierung
protected:
    // Standardberschreibungen von MFC-Klassen
    virtual void OnInitialUpdate();
    virtual void OnDraw(CDC* pDC);  // berschrieben zum Zeichnen dieser Ansicht
    virtual void OnPrepareDC(CDC* pDC, CPrintInfo* pInfo = NULL);
    virtual BOOL OnPreparePrinting(CPrintInfo* pInfo);
    virtual void OnBeginPrinting(CDC* pDC, CPrintInfo* pInfo);
    virtual void OnPrint(CDC* pDC, CPrintInfo* pInfo);

// Generierte Message-Map-Funktionen
protected:
    //{{AFX_MSG(CRowView)
    afx_msg void OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags);
    afx_msg void OnSize(UINT nType, int cx, int cy);
    afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
    //}}AFX_MSG
    DECLARE_MESSAGE_MAP()
};
    