// ex31dvw.cpp : Implementierung der Klasse CEx31dView 
//

#include "stdafx.h"
#include "ex31d.h"

#include "ex31ddoc.h"
#include "ex31dView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
/////////////////////////////////////////////////////////////////////////////
// CEx31dView

IMPLEMENT_DYNCREATE(CEx31dView, CRowView)

BEGIN_MESSAGE_MAP(CEx31dView, CRowView)
    //{{AFX_MSG_MAP(CEx31dView)
    ON_WM_SETFOCUS()
    ON_WM_MOUSEACTIVATE()
	ON_WM_TIMER()
	//}}AFX_MSG_MAP
    // Standard-Druckbefehle
    ON_COMMAND(ID_FILE_PRINT, CRowView::OnFilePrint)
    ON_COMMAND(ID_FILE_PRINT_PREVIEW, CRowView::OnFilePrintPreview)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CEx31dView Konstruktion/Destruktion

CEx31dView::CEx31dView()
{
	m_pSet = NULL;
	m_nSelectedRow = -1;
}

CEx31dView::~CEx31dView()
{
}
										
/////////////////////////////////////////////////////////////////////////////
void CEx31dView::OnUpdate(CView*, LPARAM lHint, CObject* pHint)
{
    // Wird aufgerufen, wenn der Anwender eine neue Abfrage ausfhrt
    // set m_pSet kann nicht in OnInitialUpdate gesetzt werden, da dort NULL
    ScrollToPosition(CPoint(0, 0));
    Invalidate(TRUE);
    m_nSelectedRow = -1;
	CEx31dDoc* pDoc = GetDocument();
	if((m_pSet = pDoc->m_pRecordset) != NULL) {
		UpdateScrollSizes();
	}
}

/////////////////////////////////////////////////////////////////////////////
// CRowView-berschreibungen

/////////////////////////////////////////////////////////////////////////////
void CEx31dView::OnDrawRow(CDC* pDC, int nRow, int y, BOOL bSelected)
{
//	TRACE("OnDrawRow -- %d\n", nRow);
    int x = 0;
    int i;
    CEx31dDoc* pDoc = GetDocument();
    if (m_pSet == NULL) return;
	
    if (nRow == 0) {    // Titelzeile
      for (i = 0; i < pDoc->m_nFields; i++) {
        pDC->TextOut(x, y, pDoc->m_arrayFieldName[i]);
        x += pDoc->m_arrayFieldSize[i] * m_nCharWidth;
      }	
    }
    else {
      try {
		// Ansichtszeilen werden beginnend mit 0 gezhlt, Datenstze beginnend mit 1
		// Zeile 0 ist die Titelzeile
		  m_pSet->SetAbsolutePosition(nRow);
		// IsDeleted funktioniert nicht, Ausnahme fr gelschte Zeilen muss abgefangen werden
        DrawDataRow(pDC, y);
      }
      catch (CDBException* pe) {
		if(!_strnicmp(pe->m_strError, "DATENSATZ IST GELSCHT", 17)) {
			pDC->TextOut(0, y, "**DATENSATZ GELSCHT**");
		}
		else {
			AfxMessageBox(pe->m_strError);
		}
		pe->Delete();
      }
    }
}

void CEx31dView::DrawDataRow(CDC* pDC, int y)
{
	int x = 0;
	CString strTime, str;
	CEx31dDoc* pDoc = GetDocument();
	for (int i = 0; i < pDoc->m_nFields; i++) {
	  CDBVariant var; // Muss in der Schleife deklariert werden
	  m_pSet->GetFieldValue(i, var);
	  switch (var.m_dwType) {
	  case DBVT_STRING:
		str = *var.m_pstring; // 1-Byte-Zeichen
		break;
	  case DBVT_SHORT:
		str.Format("%d", (int) var.m_iVal);
		break;
	  case DBVT_LONG:
		str.Format("%d", var.m_lVal);
		break;
	  case DBVT_SINGLE:
		str.Format("%10.2f", (double) var.m_fltVal);
		break;
	  case DBVT_DOUBLE:
		str.Format("%10.2f", var.m_dblVal);
		break;
	  case DBVT_DATE:
		str.Format("%d/%d/%d", var.m_pdate->month, var.m_pdate->day, var.m_pdate->year);
		break;
	  case DBVT_BOOL:
		str = (var.m_boolVal == 0) ? "FALSE" : "TRUE";
		break;
	  case DBVT_NULL:
		str =  "----";
		break;
	  default:
		str.Format("Unk type %d\n", var.m_dwType);
		TRACE("Unbekannter typ %d\n", var.m_dwType);
	  }
	  pDC->TextOut(x, y, str);
	  x += pDoc->m_arrayFieldSize[i] * m_nCharWidth;
	}
}

/////////////////////////////////////////////////////////////////////////////
void CEx31dView::GetRowWidthHeight(CDC* pDC, int& nRowWidth,
         int& nRowHeight, int& nCharWidth)
{
    TEXTMETRIC tm;

    CEx31dDoc* pDoc = GetDocument();
	pDC->GetTextMetrics(&tm);
    nCharWidth = tm.tmAveCharWidth + 1;
    nRowWidth = 0;
	for(int i = 0; i < pDoc->m_nFields; i++) {
	    nRowWidth += pDoc->m_arrayFieldSize[i];
	}
    nRowWidth *= nCharWidth;
    nRowHeight = tm.tmHeight;
}

/////////////////////////////////////////////////////////////////////////////
int CEx31dView::GetActiveRow()
{
    return m_nSelectedRow;
}

/////////////////////////////////////////////////////////////////////////////
int CEx31dView::GetRowCount()
{
    return GetDocument()->m_nRowCount;
}

/////////////////////////////////////////////////////////////////////////////
void CEx31dView::ChangeSelectionNextRow(BOOL bNext)
{
    if (bNext && (m_nSelectedRow < min(GetRowCount() - 1,
                LastViewableRow() - 2))) {
        m_nSelectedRow++;
    }
    if (!bNext && m_nSelectedRow) {
        m_nSelectedRow--;
    }
    UpdateRow(m_nSelectedRow);
}

/////////////////////////////////////////////////////////////////////////////
void CEx31dView::ChangeSelectionToRow(int nRow)
{
    if ((nRow >= 0) && (nRow < min(GetRowCount(), LastViewableRow() - 1))) {
        m_nSelectedRow = nRow;
    }
    UpdateRow(m_nSelectedRow);
}

/////////////////////////////////////////////////////////////////////////////
// CEx31dView Diagnose

#ifdef _DEBUG
void CEx31dView::AssertValid() const
{
    CRowView::AssertValid();
}

void CEx31dView::Dump(CDumpContext& dc) const
{
    CRowView::Dump(dc);
}

/////////////////////////////////////////////////////////////////////////////
CEx31dDoc* CEx31dView::GetDocument() // Testversion ist inline
{
    ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CEx31dDoc)));
    return (CEx31dDoc*) m_pDocument;
}

#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CEx31dView Nachrichten-Handler

/////////////////////////////////////////////////////////////////////////////
void CEx31dView::OnSetFocus(CWnd* pOldWnd)
{
    // Aktualisiert Abfrage-Zeichenfolge in Dialogleiste
	GetDocument()->PutQuery();
	CRowView::OnSetFocus(pOldWnd);
}

/////////////////////////////////////////////////////////////////////////////
int CEx31dView::OnMouseActivate(CWnd* pDesktopWnd, UINT nHitTest, UINT message)
{
	// Setzt den Fokus zurck aus der Dialogleiste
    SetFocus(); 
    return CRowView::OnMouseActivate(pDesktopWnd, nHitTest, message);
}


void CEx31dView::OnInitialUpdate() 
{
//	SetTimer(1, 5000, NULL); // alle 5 Sekunden
	CRowView::OnInitialUpdate();
}

void CEx31dView::OnTimer(UINT nIDEvent) 
{
	Invalidate(); // Ansicht mit Datenbankdaten aktualisieren
}
