// clientinetthread.cpp (verwendet MFC Wininet-Aufrufe)

#include <stdafx.h>
#include "utility.h"
#define MAXBUF 50000

HWND g_hMainWnd = 0;
char g_pchStatus[25] = "";
CCriticalSection g_csStatus;

UINT ClientWinInetThreadProc(LPVOID pParam)
{
	CCallbackInternetSession session;
	CHttpConnection* pConnection = NULL;
	CHttpFile* pFile1 = NULL;
	char* buffer = new char[MAXBUF];
	UINT nBytesRead = 0;
	DWORD dwStatus;
	try {
		// Benutzername/Kennwort funktionieren noch nicht
		if(!g_strServerName.IsEmpty()) {
			pConnection = session.GetHttpConnection(g_strServerName,
					(INTERNET_PORT) g_nPort);
		}
		else {
			pConnection = session.GetHttpConnection(g_strServerIP,
					(INTERNET_PORT) g_nPort);
		}
		pFile1 = pConnection->OpenRequest(1, g_strFile, NULL, 1, NULL, NULL, // GET-Anforderung
				INTERNET_FLAG_KEEP_CONNECTION); // Fr NT-Challenge/Response-Echtheitsprfung erforderlich
				// INTERNET_FLAG_RELOAD erzwingt erneutes Ladem vom Server (umgeht Cache des Client)
		pFile1->SendRequest();
		pFile1->QueryInfoStatusCode(dwStatus);
		TRACE("QueryInfoStatusCode = %d\n", dwStatus);
		nBytesRead = pFile1->Read(buffer, MAXBUF - 1);
		buffer[nBytesRead] = '\0'; // fr Meldungsfeld erforderlich
		char temp[100];
		if(pFile1->Read(temp, 100) != 0) { // Ermglicht Caching nach Abschluss des Lesevorgangs
			AfxMessageBox("File overran buffer -- not cached");
		}
		::MessageBox(::GetTopWindow(::GetDesktopWindow()), buffer, "WININET CLIENT", MB_OK);
		// Wir knnten pFile1 fr erneuten Aufruf von SendRequest verwenden
	}
	catch(CInternetException* e) {
		LogInternetException(pParam, e);
		e->Delete();
	}
	// Erneuter Aufruf von OpenRequest mit der gleichen Verbindung mglich
	if(pFile1) delete pFile1; // Schlieen -- Warnung ausgeben
	if(pConnection) delete pConnection; // Warum wird eine Warnung ausgegeben?
	delete [] buffer;
	g_csStatus.Lock();
	  strcpy(g_pchStatus, ""); // Problem bei leerer Zeichenfolge. bug #9897
	g_csStatus.Unlock();
	return 0;
}
