// clientsockthread.cpp (verwendet nur Winsock-Aufrufe)

#include <stdafx.h>
#include "blocksock.h"
#include "utility.h"
#define MAXBUF 50000

CString g_strIPClient;
CString g_strProxy = "ITGPROXY";
BOOL g_bUseProxy = FALSE;

UINT ClientSocketThreadProc(LPVOID pParam)
{
	// Sendet 'blinde' Anforderung, danach wird ein bestimmter URL angefordert
	CHttpBlockingSocket sClient;
	char* buffer = new char[MAXBUF];
	int nBytesReceived = 0;
	// Wir senden 'blinde' GET-Anforderung, mssen aber einen Servernamen angeben,
	// wenn wir Proxy-Server verwenden.
	// Mit der 'blinden' GET-Anforderung soll die Standard-HTML-Seite des Servers
	// geladen werden.
	// Manche Servers haben keine Standardseite und geben stattdessen einen
	// Dokumentnamen aus dem Location-Header zurck
	char request[] = "GET %s%s%s HTTP/1.0\r\n";
	char headers[] =
		"User-Agent: Mozilla/1.22 (Windows; U; 32bit)\r\n"
		"Accept: */*\r\n"
		"Accept: image/gif\r\n"
		"Accept: image/x-xbitmap\r\n"
		"Accept: image/jpeg\r\n"
// Mit der folgenden Zeile wird getestet, ob der Server den URL nicht senden kann
//		"If-Modified-Since: Wed, 11 Sep 1996 20:23:04 GMT\r\n"
		"\r\n"; // erforderlich
	CSockAddr saServer, saPeer, saTest, saClient;
	try {
		sClient.Create();
		if(!g_strIPClient.IsEmpty()) {
			// Funktioniert nicht, wenn das Netzwerk die IP-Adressen vergibt.
			// Funktioniert nur in Intranets, in denen Client-Computer mehrere
			// IP-Adressen haben knnen
			saClient = CSockAddr(g_strIPClient);
			sClient.Bind(saClient);
		}
		if(g_bUseProxy) {
			saServer = CBlockingSocket::GetHostByName(g_strProxy, 80);
		}
		else {
			if(g_strServerIP.IsEmpty()) {
				saServer = CBlockingSocket::GetHostByName(g_strServerName, g_nPort);
			}
			else {
				saServer = CSockAddr(g_strServerIP, g_nPort);
			}
		}
		sClient.Connect(saServer);
		sClient.GetSockAddr(saTest);
		TRACE("SOCK CLIENT: GetSockAddr = %s, %d\n", saTest.DottedDecimal(), saTest.Port());
		if(g_bUseProxy) {
			wsprintf(buffer, request, "http://" , (const char*) g_strServerName, g_strFile);
		}
		else {
			wsprintf(buffer, request, "", "", g_strFile);
		}
		sClient.Write(buffer, strlen(buffer), 10);
		sClient.Write(headers, strlen(headers), 10);
		// Alle Antwort-Header des Servers lesen
		do {
			nBytesReceived = sClient.ReadHttpHeaderLine(buffer, MAXBUF, 10);
			TRACE("SOCK CLIENT: %s", buffer);
		} while(strcmp(buffer, "\r\n"));
		// Datei des Servers lesen
		nBytesReceived = sClient.ReadHttpResponse(buffer, MAXBUF, 10);
		TRACE("SOCK CLIENT: bytes received = %d\n", nBytesReceived);
		if(nBytesReceived == 0) {
			AfxMessageBox("Keine Antwort erhalten. Ungltiger URL?");
		}
		else {
			buffer[nBytesReceived] = '\0';
			::MessageBox(::GetTopWindow(::GetDesktopWindow()), buffer, "WINSOCK CLIENT", MB_OK);
		}

		// Wir knnte weitere Anforderung mit sClient senden, indem wir Close, dann Create aufrufen, etc.
	}
	catch(CBlockingSocketException* e) {
		LogBlockingSocketException(pParam, "CLIENT:", e);
		e->Delete();
	}
	sClient.Close();
	delete [] buffer;
	return 0;
}
