// serverthread.cpp

#include <stdafx.h>
#include "blocksock.h"
#include "utility.h"
#define SERVERMAXBUF 5000
#define MAXLINELENGTH 100

//#define USE_TRANSMITFILE // Kommentarzeichen entfernen, falls Sie mit Windows NT arbeiten

volatile BOOL g_bListening = FALSE;
volatile UINT g_nPortServer = 80;

CString g_strDirect = "\\vcpp32\\ex34a\\WebSite";
CString g_strIPServer;
CString g_strDefault = "default.htm";
CBlockingSocket g_sListen;

BOOL Parse(char* pStr, char** ppToken1, char** ppToken2)
// einfache Parsing-Routine
// (muss zwei Token finden, denen jeweils ein Leerzeichen folgt)
{
	*ppToken1 = pStr;
	char* pch = strchr(pStr, ' ');
	if(pch) {
		*pch = '\0';
		pch++;
		*ppToken2 = pch;
		pch = strchr(pch, ' ');
		if(pch) {
			*pch = '\0';
			return TRUE;
		}
	}
	return FALSE;
}

void LogRequest(LPVOID pParam, char* pch, CSockAddr sa)
{	// pParam enthlt HWND des Zielfensters (in anderem Thread)
	CString strGmt = CTime::GetCurrentTime().FormatGmt("%m/%d/%y %H:%M:%S GMT");
	char text1[1000];
	wsprintf(text1, "SERVER-VERBINDUNG # %d: IP-Adresse = %s, Port = %d -- %s\r\n",
		g_nConnection, sa.DottedDecimal(), sa.Port(),  (const char*) strGmt);
	strcat(text1, pch);
	::SendMessage((HWND) pParam, EM_SETSEL, (WPARAM) 65534, 65535);
	::SendMessage((HWND) pParam, EM_REPLACESEL, (WPARAM) 0, (LPARAM) text1);
}

CFile* OpenFile(const char* pName)
{
	// Falls es ein Verzeichnis ist, Standard-HTML-Datei ffnen
	CFileException e;
	CFile* pFile = new CFile();
	if(*pName == '/') pName++;
	CString strName = pName;
	if(pFile->Open(strName, CFile::modeRead, &e)) {
		return pFile;
	}
	if((e.m_cause == CFileException::accessDenied) ||
			(e.m_cause == CFileException::badPath)) { // Verzeichnis?
		int nLength;
		// Sofern nicht 'Stammverzeichnis', / hinzufgen
		if((nLength = strName.GetLength()) > 1) {
			if(strName[nLength - 1] != '/') {
				strName += '/';
			}
		}
		strName += g_strDefault;
		if(pFile->Open(strName, CFile::modeRead, &e)) {
			return pFile;
		}
	}
	delete pFile;
	return NULL;
}

UINT ServerThreadProc(LPVOID pParam)
{
	CSockAddr saClient;
	CHttpBlockingSocket sConnect;
	char* buffer = new char[SERVERMAXBUF];
	char message[100], headers[500], request1[MAXLINELENGTH],  request2[MAXLINELENGTH];
	char hdrErr[] = "HTTP/1.0 404 Object Not Found\r\n"
				   "Server: Inside Visual C++ SOCK01\r\n"
				   "Content-Type: text/html\r\n"
				   "Accept-Ranges: bytes\r\n"
				   "Content-Length: 66\r\n\r\n" // WinInet braucht korrekte Lnge
				   "<html><h1><body>HTTP/1.0 404 Objekt nicht gefunden</h1></body></html>\r\n";
	char hdrFmt[] = "HTTP/1.0 200 OK\r\n"
				   "Server: Inside Visual C++ EX34A\r\n"
				   "Date: %s\r\n"
				   "Content-Type: text/html\r\n"
				   "Accept-Ranges: bytes\r\n"
				   "Content-Length: %d\r\n";
	char html1[] = "<html><head><title>Inside Visual C++ \
		               Server</title></head>\r\n"
				   "<body><body background=\"/samples/images/usa1.jpg\">\r\n"
				   "<h1><center>Dies ist eine Startseite</center></h1><p>\r\n"
				   "<a href=\"/samples/iisdocs.htm\">Hier klicken fr iisdocs.htm.</a><p>\r\n"
				   "<a href=\"/samples/disclaim.htm\">Hier klicken fr disclaim.htm.</a><p>\r\n";
					// Hier benutzerdefinierte Meldungen einfgen
	char html2[] = "</body></html>\r\n\r\n";
	CString strGmtNow = CTime::GetCurrentTime().FormatGmt("%a, %d %b %Y %H:%M:%S GMT");
	int nBytesSent = 0;
	CFile* pFile = NULL;
	try {
		if(!g_sListen.Accept(sConnect, saClient)) {
			// Ansicht oder Anwendung haben Socket geschlossen
			g_bListening = FALSE;
			delete [] buffer;
			return 0;
		}
		g_nConnection++;
		::SetCurrentDirectory(g_strDirect);
		AfxBeginThread(ServerThreadProc, pParam, THREAD_PRIORITY_NORMAL);
		// Anforderung des Client lesen
		sConnect.ReadHttpHeaderLine(request1, MAXLINELENGTH, 10);
		LogRequest(pParam, request1, saClient);
		char* pToken1; char* pToken2;
		if(Parse(request1, &pToken1, &pToken2)) {
			if(!stricmp(pToken1, "GET")) {
				do { // brige Header verarbeiten
					sConnect.ReadHttpHeaderLine(request2, MAXLINELENGTH, 10);
					TRACE("SERVER: %s", request2);
				}
				while(strcmp(request2, "\r\n"));
				if(!stricmp(pToken2, "/custom")) { // spezielle Anforderung
					// "benutzerdefinierte" HTML-Seite senden
					wsprintf(message, "Hallo! Sie haben Verbindung #%d an IP %s, Port %d<p>%s",
							g_nConnection, saClient.DottedDecimal(), saClient.Port(), strGmtNow);
					wsprintf(headers, hdrFmt, (const char*) strGmtNow, strlen(html1)
									+ strlen(message) + strlen(html2));
					// kein If-Modified
					strcat(headers, "\r\n"); // Leerzeile
					sConnect.Write(headers, strlen(headers), 10);
					sConnect.Write(html1, strlen(html1), 10);
					sConnect.Write(message, strlen(message), 10);
					sConnect.Write(html2, strlen(html2), 10);
				}
				else if(strchr(pToken2, '?')) { // CGI-Anforderung
					// Netscape bergibt in GET-Anforderung keine Funktionsnamen
					TRACE("SERVER: CGI-Anforderung gefunden %s\n", pToken2);
					// Wir knnten hier die ISAPI DLL laden und ausfhren
				}
				else { // Muss Datei sein
					// Setzt voraus, das Programm hat bereits das Standard-WWW-Verzeichnis eingestellt
					if((pFile = OpenFile(pToken2)) != NULL) {
						CFileStatus fileStatus;
						pFile->GetStatus(fileStatus);
						CString strGmtMod = fileStatus.m_mtime.FormatGmt("%a, %d %b %Y %H:%M:%S GMT");
						char hdrModified[50];
						wsprintf(hdrModified, "Zuletzt gendert: %s\r\n\r\n", (const char*) strGmtMod);
						DWORD dwLength = pFile->GetLength();
						// Datum: , Content-Length:
						wsprintf(headers, hdrFmt,  (const char*) strGmtNow, dwLength);
						strcat(headers, hdrModified);
						nBytesSent = sConnect.Write(headers, strlen(headers), 10);
						TRACE("SERVER: Header-Zeichen gesendet = %d\n", nBytesSent);
						// Datei sollte nur gesendet werden, falls If-Modified-Since-Datum
						// kleiner als die Variable m_mtime der Datei ist
						nBytesSent = 0;
#ifdef USE_TRANSMITFILE
						if(::TransmitFile(sConnect, (HANDLE) pFile->m_hFile, dwLength,
								0, NULL, NULL, TF_DISCONNECT)) {
							nBytesSent = (int) dwLength;
						}
#else
						DWORD dwBytesRead = 0;
						UINT uBytesToRead;
						// Datei in kleinen Stcken (5K) bertragen, um Speicher zu sparen
						while(dwBytesRead < dwLength) {
							uBytesToRead = min(SERVERMAXBUF, dwLength - dwBytesRead);
							VERIFY(pFile->Read(buffer, uBytesToRead) == uBytesToRead);
							nBytesSent += sConnect.Write(buffer, uBytesToRead, 10);
							dwBytesRead += uBytesToRead;
						}
#endif
						TRACE("SERVER: Die gesamte Datei wurde gesendet.\n");
					}
					else {
						nBytesSent = sConnect.Write(hdrErr, strlen(hdrErr), 10); // 404 Objekt nicht gefunden
					}
				}
			}
			else if(!stricmp(pToken1, "POST")) {
				do { // brige Header bis Leerzeile verarbeiten
					sConnect.ReadHttpHeaderLine(request2, MAXLINELENGTH, 10);
					TRACE("SERVER: POST %s", request2);
				}
				while(strcmp(request2, "\r\n"));
				// Vom Client gesendete Datenzeile lesen
				sConnect.ReadHttpHeaderLine(request2, MAXLINELENGTH, 10);
				TRACE("SERVER: POST-PARAMETER = %s\n", request2);
				LogRequest(pParam, request2, saClient);
				// Hier ISAPI DLL starten?
				nBytesSent = sConnect.Write(hdrErr, strlen(hdrErr), 10); // 404 Fehler
			}
			else {
				TRACE("SERVER: %s (kein GET- oder POST-Befehl)\n", pToken1);
				// Header knnen nicht verarbeitet werden
			}
		}
		else {
			TRACE("SERVER: ungltige Anforderung\n");
		}
		sConnect.Close(); // Destruktor kann die Verbindung nicht schlieen
	}
	catch(CBlockingSocketException* pe) {
		LogBlockingSocketException(pParam, "SERVER:", pe);
		pe->Delete();
	}
	TRACE("SERVER: Zeichen der Datei gesendet = %d\n", nBytesSent);
	delete [] buffer;
	if(pFile) delete pFile;
	return 0;
}


