// utility.cpp -- Enthlt Routinen, die von mehreren Threads verwendet werden
#include <stdafx.h>
#include "blocksock.h"
#include "utility.h"

volatile int g_nConnection = 0; // Verbindungsnummer
CString g_strServerName = "localhost"; // wird sowohl von Winsock als auch Wininet verwendet
CString g_strServerIP;
volatile UINT g_nPort = 80;
CString g_strFile = "/custom";

CCallbackInternetSession::CCallbackInternetSession( LPCTSTR pstrAgent, DWORD dwContext,
	 DWORD dwAccessType, LPCTSTR pstrProxyName, LPCTSTR pstrProxyBypass, DWORD dwFlags) :
	CInternetSession(pstrAgent, dwContext, dwAccessType, pstrProxyName, pstrProxyBypass, dwFlags)
{
	EnableStatusCallback();
}

void CCallbackInternetSession::OnStatusCallback(DWORD dwContext, DWORD dwInternalStatus,
		LPVOID lpvStatusInformation, DWORD dwStatusInformationLength)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());
	int errors[] = {10, 11, 20, 21, 30, 31, 40, 41, 42, 43, 50, 51, 60, 70, 100, 110, 0};
	char* text[] = { 
		"Name wird gesucht",       	
		"Name wurde zugeordnet",       
		"Verbindung zum Server wird hergestellt",
		"Server-Verbindung besteht",  
		"Sende Anforderung",      
		"Anforderung wurde gesendet",         
		"Empfange Antwort",   
		"Antwort wurde empfangen",    
		"Steuerungsbefehl empfangen",
		"Prefetch",             
		"Trenne Verbindung",   
		"Verbindung wurde geschlossen",    
		"Zugriffsnummer wird erstellt",       
		"Zugriffsnummer wird geschlossen",       
		"Anforderung abgeschlossen",     
		"Weiterleiten",
		"Unbekannt" };
	int n;
/*  // Demonstriert den Abbruch einer Anforderung
	if(dwInternalStatus == INTERNET_STATUS_REQUEST_SENT) {
		AfxThrowInternetException(dwContext, 999);
	}
*/
	for(n = 0; errors[n] != 0; n++) {
		if(errors[n] == (int) dwInternalStatus) break;
	}
	g_csStatus.Lock();
	  strcpy(g_pchStatus, text[n]);
	  if(dwInternalStatus  == INTERNET_STATUS_RESOLVING_NAME || 
				dwInternalStatus == INTERNET_STATUS_NAME_RESOLVED) {
		strcat(g_pchStatus, "-");
		strcat(g_pchStatus, (char*) lpvStatusInformation);
	  }
	  TRACE("WININET-STATUS: %s\n", g_pchStatus);
	g_csStatus.Unlock();
	// Rahmen braucht keine Zugriffsnummer - Nachricht lst OnIdle-Aufruf aus, womit Statusleiste aktualisiert wird
	::PostMessage(g_hMainWnd, WM_CALLBACK, 0, 0);
}

void LogInternetException(LPVOID pParam, CInternetException* pe)
{	// pParam speichert HWND des Zielfenster (in anderem Thread)
	CString strGmt = CTime::GetCurrentTime().FormatGmt("%m/%d/%y %H:%M:% GMT");
	char text1[300], text2[100];
	wsprintf(text1, "CLIENT-FEHLER: WinInet-Fehler #%d -- %s\r\n   ",
		pe->m_dwError, (const char*) strGmt);
	pe->GetErrorMessage(text2, 99);
	strcat(text1, text2);
	if(pe->m_dwError == 12152) {
		strcat(text1, "  URL nicht gefunden?\r\n");
	}
	::SendMessage((HWND) pParam, EM_SETSEL, (WPARAM) 65534, 65535);
	::SendMessage((HWND) pParam, EM_REPLACESEL, (WPARAM) 0, (LPARAM) text1);
}

