// EX35A.CPP - Implementierungsdatei fr Ihren Internet-Server
//    ex35a Extension

#include "stdafx.h"
#include "ex35a.h"

///////////////////////////////////////////////////////////////////////
// Das einzige CWinApp-Objekt
// HINWEIS: Sie knnen dieses Objekt entfernen, wenn Sie Ihr Projekt in ein
// Nicht-MFC-Projekt ndern und in einer DLL verwenden.

CWinApp theApp;

///////////////////////////////////////////////////////////////////////
// Tabelle zur Befehlsinterpretation

BEGIN_PARSE_MAP(CEx35aExtension, CHttpServer)
	ON_PARSE_COMMAND(ConfirmOrder, CEx35aExtension, ITS_PSTR)
	ON_PARSE_COMMAND_PARAMS("name") 
	ON_PARSE_COMMAND(ProcessPizzaForm, CEx35aExtension, ITS_PSTR ITS_PSTR ITS_I4 ITS_PSTR ITS_PSTR ITS_PSTR ITS_PSTR ITS_PSTR)
	ON_PARSE_COMMAND_PARAMS("name address quantity size top1=~ top2=~ top3=~ top4=~") 
	ON_PARSE_COMMAND(ProcessTimesheet, CEx35aExtension, ITS_I4 ITS_PSTR ITS_R8 ITS_I4)
	ON_PARSE_COMMAND_PARAMS("Period Employee Hours Job") 
	ON_PARSE_COMMAND(Default, CEx35aExtension, ITS_EMPTY)
	DEFAULT_PARSE_COMMAND(Default, CEx35aExtension)
END_PARSE_MAP(CEx35aExtension)


///////////////////////////////////////////////////////////////////////
// Das einzige CEx35aExtension-Objekt

CEx35aExtension theExtension;


///////////////////////////////////////////////////////////////////////
// CEx35aExtension Implementierung

CEx35aExtension::CEx35aExtension()
{
	m_nTotalPizzaOrders = 0;
}

CEx35aExtension::~CEx35aExtension()
{
}

BOOL CEx35aExtension::GetExtensionVersion(HSE_VERSION_INFO* pVer)
{
	// Aufruf der Standardimplementierung fr die Initialisierung
	CHttpServer::GetExtensionVersion(pVer);

	// Einlesen der Beschreibungszeichenfolge
	TCHAR sz[HSE_MAX_EXT_DLL_NAME_LEN+1];
	ISAPIVERIFY(::LoadString(AfxGetResourceHandle(),
			IDS_SERVER, sz, HSE_MAX_EXT_DLL_NAME_LEN));
	_tcscpy(pVer->lpszExtensionDesc, sz);
	return TRUE;
}

///////////////////////////////////////////////////////////////////////
// CEx35aExtension Befehls-Handler

void CEx35aExtension::Default(CHttpServerContext* pCtxt)
{
	StartContent(pCtxt);
	WriteTitle(pCtxt);

	*pCtxt << _T("This default message was produced by the Internet");
	*pCtxt << _T(" Server DLL Wizard. Edit your CEx35aExtension::Default()");
	*pCtxt << _T(" implementation to change it.\r\n");

	EndContent(pCtxt);
}

void CEx35aExtension::ConfirmOrder(CHttpServerContext* pCtxt, LPCTSTR pstrName)
{
	StartContent(pCtxt);
	WriteTitle(pCtxt);
	*pCtxt << "<p>Sie erhalten Ihre Pizza in etwa 30 Minuten.";
	*pCtxt << "<p>Vielen Dank, " << pstrName << ", fr Ihre Bestellung bei CyberPizza.";
	// Bestellung jetzt von der Festplatte laden und Pizza backen
	// Falls der Kunde die Bestellung nicht besttigt, muss die Bestellung gelscht werden.
	m_cs.Lock(); // muss threadsicher sein
	  long int nTotal = ++m_nTotalPizzaOrders;
	m_cs.Unlock();
	*pCtxt << "<p>Pizzabestellungen gesamt = " << nTotal;
	EndContent(pCtxt);
}

void CEx35aExtension::ProcessPizzaForm(CHttpServerContext* pCtxt, LPCTSTR pstrName,
				LPCTSTR pstrAddr, int nQuantity, LPCTSTR pstrSize,
				LPCTSTR pstrTop1, LPCTSTR pstrTop2,	LPCTSTR pstrTop3, LPCTSTR pstrTop4)
{
	StartContent(pCtxt);
	WriteTitle(pCtxt);
  if((strlen(pstrName) > 0) && (strlen(pstrAddr) > 0)) {
    *pCtxt << " Ihre Pizzabstellung lautet wie folgt:";
    *pCtxt << "<p>Name: " << pstrName;
    *pCtxt << "<p>Anschrift: " << pstrAddr;
    *pCtxt << "<p>Menge: " << (long int) nQuantity;
    *pCtxt << "<p>Gre: " << pstrSize;
    *pCtxt << "<p>Zutaten: " << pstrTop1 << " " << pstrTop2 << " " <<
      pstrTop3 << " " << pstrTop4;
    *pCtxt << "<p>Rechnungsbetrag DM 23,49, "
              "inklusive Lieferung.";
    *pCtxt << "<form action=\"ex35a.dll?ConfirmOrder\" method=POST>";
    *pCtxt << "<p><input type=\"hidden\" name=\"name\" value=\"" <<
      pstrName << "\">";             // Verweis auf Originalbestellung
    *pCtxt << "<p><input type=\"submit\"value=\"Besttigen und Kreditkarte belasten\">";
    *pCtxt << "</form>";
    // Diese Bestellung in einer Datei oder Datenbank speichern,
    // Zugriff ber den Namen
  }
  else {
    *pCtxt << "Sie haben Ihren Namen oder Ihre Anschrift nicht angegeben. "
              "Bitte prfen Sie Ihre Angaben, und versuchen Sie es erneut.";
  }
	EndContent(pCtxt);
}

void CEx35aExtension::ProcessTimesheet(CHttpServerContext* pCtxt, int nPeriod,
				LPCTSTR pstrEmployee, double dHours, int nJob)
{
	StartContent(pCtxt);
	WriteTitle(pCtxt);
	*pCtxt << " Arbeitszeiterfassung:";
	*pCtxt << "<p>Zeitraum: " << (long int) nPeriod;
	*pCtxt << "<p>Mitarbeiter: " << pstrEmployee;
	*pCtxt << "<p>Stunden: " << dHours;
	*pCtxt << "<p>Position: " << (long int) nJob;
	// diese Transaktion in einer Datei oder Datenbank speichern
	EndContent(pCtxt);
}

// Die folgenden Zeilen nicht bearbeiten. Sie werden vom Klassenassistenten bentigt.
#if 0
BEGIN_MESSAGE_MAP(CEx35aExtension, CHttpServer)
	//{{AFX_MSG_MAP(CEx35aExtension)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()
#endif	// 0



///////////////////////////////////////////////////////////////////////
// If your extension will not use MFC, you'll need this code to make
// sure the extension objects can find the resource handle for the
// module.  If you convert your extension to not be dependent on MFC,
// remove the comments arounn the following AfxGetResourceHandle()
// and DllMain() functions, as well as the g_hInstance global.

/****

static HINSTANCE g_hInstance;

HINSTANCE AFXISAPI AfxGetResourceHandle()
{
	return g_hInstance;
}

BOOL WINAPI DllMain(HINSTANCE hInst, ULONG ulReason,
					LPVOID lpReserved)
{
	if (ulReason == DLL_PROCESS_ATTACH)
	{
		g_hInstance = hInst;
	}

	return TRUE;
}

****/

LPCTSTR CEx35aExtension::GetTitle() const
{
	return "Ex35a Pizza-Erweiterung";
}
