// SrvrItem.cpp : Implementierung der Klasse CEx36bSrvrItem
//

#include "stdafx.h"
#include "ex36b.h"

#include "ex36bDoc.h"
#include "SrvrItem.h"
#include "CntrItem.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CEx36bSrvrItem Implementierung

IMPLEMENT_DYNAMIC(CEx36bSrvrItem, CDocObjectServerItem)

CEx36bSrvrItem::CEx36bSrvrItem(CEx36bDoc* pContainerDoc)
	: CDocObjectServerItem(pContainerDoc, TRUE)
{
	// ZU ERLEDIGEN: Hier Code fr One-Time-Konstruktion einfgen
	//  (z.B. Hinzufgen von zustzlichen Zwischenablageformaten zur Datenquelle des Elements)
}

CEx36bSrvrItem::~CEx36bSrvrItem()
{
	// ZU ERLEDIGEN: Hier Bereinigungscode hinzufgen
}

void CEx36bSrvrItem::Serialize(CArchive& ar)
{
	// CEx36aSrvrItem::Serialize wird automatisch aufgerufen, wenn
	//  das Element in die Zwischenablage kopiert wird. Dies kann automatisch 
	//  ber die OLE-Rckruffunktion OnGetClipboardData geschehen. Ein Standardwert fr
	//  das eingebundene Element dient einfach zur Delegierung der Serialisierungsfunktion des 
	//  Dokuments. Wenn Sie Verweise untersttzen, mchten Sie vielleicht nur einen Teil des
	//  Dokuments serialisieren.

	if (!IsLinkedItem())
	{
		CEx36bDoc* pDoc = GetDocument();
		ASSERT_VALID(pDoc);
		pDoc->Serialize(ar);
	}
}

BOOL CEx36bSrvrItem::OnGetExtent(DVASPECT dwDrawAspect, CSize& rSize)
{
	// Die meisten Anwendungen (wie auch diese) untersttzen als einzigen Aspekt das Zeichnen
	//  des Elementinhalts. Wollen Sie andere Aspekte untersttzen, wie z.B.
	//  DVASPECT_THUMBNAIL (durch berladen von OnDrawEx), so sollte diese
	//  Implementierung von OnGetExtent dahingehend modifiziert werden, dass sie
	//  zustzliche Aspekte verarbeiten kann.

	if (dwDrawAspect != DVASPECT_CONTENT)
		return CDocObjectServerItem::OnGetExtent(dwDrawAspect, rSize);

	// CEx36aSrvrItem::OnGetExtent wird aufgerufen, um das Extent in 
	//  HIMETRIC-Einheiten des gesamten Elements zu ermitteln. Die Standardimplementierung
	//  liefert hier einfach eine fest programmierte Einheitenanzahl zurck.

	CEx36bDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	// ZU ERLEDIGEN: Ersetzen Sie diese willkrlich gewhlte Gre

	rSize = CSize(3000, 3000);   // 3000 x 3000 HIMETRIC Einheiten

	return TRUE;
}

BOOL CEx36bSrvrItem::OnDraw(CDC* pDC, CSize& rSize)
{
	CEx36bDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	// ZU ERLEDIGEN: Setzen Sie Mapping-Modus und Extent
	//  (Das Extent stimmt blicherweise mit der von OnGetExtent zurckgelieferten Gre berein)
	pDC->SetMapMode(MM_ANISOTROPIC);
	pDC->SetWindowOrg(0,0);
	pDC->SetWindowExt(3000, 3000);

	// ZU ERLEDIGEN: Hier Code zum Zeichnen einfgen. Fllen Sie wahlweise das HIMETRIC-Extent aus.
	//  Alle Zeichenoperationen finden innerhalb des Metadatei-Gertekontexts (pDC) statt.

	// ZU ERLEDIGEN: Auch eingebundene CEx36aCntrItem-Objekte zeichnen.

	// Der folgende Code zeichnet das erste Element an einer willkrlich gewhlten Position.

	// ZU ERLEDIGEN: Entfernen Sie diesen Code, sobald Ihre richtige Zeichenroutine vollstndig ist

	POSITION pos = pDoc->GetStartPosition();
	CEx36bCntrItem* pItem = (CEx36bCntrItem*)pDoc->GetNextClientItem(pos);
	if (pItem != NULL)
		pItem->Draw(pDC, CRect(10, 10, 1010, 1010));
	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// CEx36bSrvrItem Diagnose

#ifdef _DEBUG
void CEx36bSrvrItem::AssertValid() const
{
	CDocObjectServerItem::AssertValid();
}

void CEx36bSrvrItem::Dump(CDumpContext& dc) const
{
	CDocObjectServerItem::Dump(dc);
}
#endif

/////////////////////////////////////////////////////////////////////////////
