// valform.cpp
//
#include "stdafx.h"
#include "valform.h"

IMPLEMENT_DYNAMIC(CValidForm, CFormView)

BEGIN_MESSAGE_MAP(CValidForm, CFormView)
	//{{AFX_MSG_MAP(CValidForm)
	ON_MESSAGE(WM_VALIDATE, OnValidate)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

CValidForm::CValidForm(UINT ID) : CFormView(ID)
{
	TRACE("CValidForm ctor\n");
    m_bValidationOn = TRUE;                      // Validierung aktivieren
}

void CValidForm::ValidateDlgItem(CDataExchange* pDX, UINT ID)
{
	// Sofern im Formular nicht berschrieben, 
	ASSERT(this);
	TRACE("CValidForm::ValidateDlgItem (sollte berschrieben werden)\n");
	return;
}


BOOL CValidForm::OnCommand(WPARAM wParam, LPARAM lParam) 
{
	// speziell fr WIN32 -- wParam/lParam werden unter WIN16 anders verarbeitet
 	TRACE("CValidForm::OnCommand, wParam = %x, lParam = %x\n", wParam, lParam);
	TRACE("m_bValidationOn = %d\n", m_bValidationOn);
	if(m_bValidationOn) {   // mglicherweise KillFocus
        UINT notificationCode = (UINT) HIWORD( wParam );
        if((notificationCode == EN_KILLFOCUS)  ||
           (notificationCode == LBN_KILLFOCUS) ||
           (notificationCode == CBN_KILLFOCUS) ) {
            CWnd* pFocus = CWnd::GetFocus(); // statischer Funktionsaufruf 
            // Falls ein anderes Steuerelement desselben Formulars den Fokus erhlt
            if( pFocus && (pFocus->GetParent() == this) ){
            	if(pFocus->GetDlgCtrlID() != IDCANCEL) {
            	    // und die Schaltflche Abbrechen nicht den Fokus besitzt,
                    // nach dem Zeichnen validieren
                	BOOL rtn = PostMessage( WM_VALIDATE, wParam );
					TRACE("posted message, rtn = %d\n", rtn);
				}
            }
        }
    }
	return CFormView::OnCommand(wParam, lParam); 
}


LONG CValidForm::OnValidate(UINT wParam, LONG lParam)
{
	TRACE("Eintritt CValidForm::OnValidate\n");
	CDataExchange dx(this, TRUE);
    m_bValidationOn = FALSE;               // temporarr deaktivieren
    UINT controlID = (UINT) LOWORD( wParam );
	try {
	    ValidateDlgItem(&dx, controlID);
	}
	catch(CUserException* pUE) {
		pUE->Delete();
		TRACE("CValidForm hat Ausnahme abgefangen.\n");
		// Anwender wird ber Meldungsfeld benachrichtigt
	}
    m_bValidationOn = TRUE;
    return 0;                            // geht nicht weiter
}

