// ex36bView.cpp : Implementierung der Klasse CEx36bView
//

#include "stdafx.h"
#include "ex36b.h"

#include "ex36bDoc.h"
#include "CntrItem.h"
#include "ex36bView.h"
#include "AddrDialog.h"
#include "PostThread.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CEx36bView

IMPLEMENT_DYNCREATE(CEx36bView, CValidForm)

BEGIN_MESSAGE_MAP(CEx36bView, CValidForm)
	//{{AFX_MSG_MAP(CEx36bView)
	ON_WM_SETFOCUS()
	ON_WM_SIZE()
	ON_COMMAND(ID_OLE_INSERT_NEW, OnInsertObject)
	ON_COMMAND(ID_CANCEL_EDIT_CNTR, OnCancelEditCntr)
	ON_COMMAND(ID_CANCEL_EDIT_SRVR, OnCancelEditSrvr)
	ON_BN_CLICKED(IDC_SUBMIT, OnSubmit)
	ON_BN_CLICKED(IDCANCEL, OnCancel)
	ON_COMMAND(ID_SERVER_ADDRESS, OnServerAddress)
	ON_MESSAGE(WM_POSTCOMPLETE, OnPostComplete)
	//}}AFX_MSG_MAP
	// Standard-Druckbefehle
	ON_COMMAND(ID_FILE_PRINT, CValidForm::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, CValidForm::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CValidForm::OnFilePrintPreview)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CEx36bView Konstruktion/Destruktion

CEx36bView::CEx36bView()
	: CValidForm(CEx36bView::IDD)
{
	//{{AFX_DATA_INIT(CEx36bView)
	m_dHours = 0.0;
	m_strEmployee = _T("");
	m_nJob = 0;
	m_nPeriod = 0;
	//}}AFX_DATA_INIT
	m_pSelection = NULL;
	// ZU ERLEDIGEN: Hier Code zur Konstruktion einfgen,

}

CEx36bView::~CEx36bView()
{
}

void CEx36bView::DoDataExchange(CDataExchange* pDX)
{
	CValidForm::DoDataExchange(pDX);
	DDX_CBString(pDX, IDC_EMPLOYEE, m_strEmployee);
	DDV_MaxChars(pDX, m_strEmployee, 10);
	if(pDX->m_bSaveAndValidate && m_strEmployee.IsEmpty()) {
		AfxMessageBox("Must supply an employee name");
		pDX->Fail();
	}
	//{{AFX_DATA_MAP(CEx36bView)
	DDX_Text(pDX, IDC_HOURS, m_dHours);
	DDV_MinMaxDouble(pDX, m_dHours, 0.1, 100.);
	DDX_Text(pDX, IDC_JOB, m_nJob);
	DDV_MinMaxInt(pDX, m_nJob, 1, 20);
	DDX_Text(pDX, IDC_PERIOD, m_nPeriod);
	//}}AFX_DATA_MAP
}

BOOL CEx36bView::PreCreateWindow(CREATESTRUCT& cs)
{
	// ZU ERLEDIGEN: ndern Sie hier die Fensterklasse oder das Erscheinungsbild, indem Sie
	//  CREATESTRUCT cs modifizieren.

	return CValidForm::PreCreateWindow(cs);
}

void CEx36bView::OnInitialUpdate()
{
	CEx36bDoc* pDoc = GetDocument();
	m_nPeriod = pDoc->m_nPeriod;
	UpdateData(FALSE);

	// ZU ERLEDIGEN: Entfernen Sie diesen Code, sobald der endgltige Code fr das Auswahlmodell geschrieben ist
	m_pSelection = NULL;    // Auswahl initialisieren

}

/////////////////////////////////////////////////////////////////////////////
// CEx36bView Drucken

BOOL CEx36bView::OnPreparePrinting(CPrintInfo* pInfo)
{
	// Standardvorbereitung
	return DoPreparePrinting(pInfo);
}

void CEx36bView::OnBeginPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// ZU ERLEDIGEN: Zustzliche Initialisierung vor dem Drucken hier einfgen
}

void CEx36bView::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// ZU ERLEDIGEN: Hier Bereinigungsarbeiten nach dem Drucken einfgen
}

void CEx36bView::OnPrint(CDC* pDC, CPrintInfo*)
{
	// ZU ERLEDIGEN: Benutzerdefinierten Code zum Ausdrucken hier einfgen
}

/////////////////////////////////////////////////////////////////////////////
// OLE-Client-Untersttzung und -Befehle

BOOL CEx36bView::IsSelected(const CObject* pDocItem) const
{
	// Die nachfolgende Implementierung ist angemessen, wenn sich Ihre Auswahl nur aus
	//  CEx36bCntrItem-Objekten zusammensetzt. Zur Bearbeitung unterschiedlicher 
	//  Auswahlmechanismen sollte die hier gegebene Implementierung ersetzt werden.

	// ZU ERLEDIGEN: Implementieren Sie diese Funktion, die auf ein ausgewhltes OLE-Client-Element testet

	return pDocItem == m_pSelection;
}

void CEx36bView::OnInsertObject()
{
	// Standarddialogfeld zum Einfgen von Objekten aufrufen, um Infos abzufragen
	//  fr neues CEx36bCntrItem-Objekt.
	COleInsertDialog dlg;
	if (dlg.DoModal() != IDOK)
		return;

	BeginWaitCursor();

	CEx36bCntrItem* pItem = NULL;
	TRY
	{
		// Neues, mit diesem Dokument verbundenes Element erzeugen.
		CEx36bDoc* pDoc = GetDocument();
		ASSERT_VALID(pDoc);
		pItem = new CEx36bCntrItem(pDoc);
		ASSERT_VALID(pItem);

		// Element mit Dialogfelddaten initialisieren.
		if (!dlg.CreateItem(pItem))
			AfxThrowMemoryException();  // Beliebige Ausnahme erzeugen
		ASSERT_VALID(pItem);

		// If item created from class list (not from file) then launch
		//  the server to edit the item.
		if (dlg.GetSelectionType() == COleInsertDialog::createNewItem)
			pItem->DoVerb(OLEIVERB_SHOW, this);

		ASSERT_VALID(pItem);

		// Die Gre wird hier willkrlich auf die Gre
		//  des zuletzt eingefgten Elements gesetzt.

		// ZU ERLEDIGEN: Implementieren Sie die Auswahl erneut in einer fr Ihre Anwendung geeigneten Weise


		m_pSelection = pItem;   // set selection to last inserted item
		pDoc->UpdateAllViews(NULL);
	}
	CATCH(CException, e)
	{
		if (pItem != NULL)
		{
			ASSERT_VALID(pItem);
			pItem->Delete();
		}
		AfxMessageBox(IDP_FAILED_TO_CREATE);
	}
	END_CATCH

	EndWaitCursor();
}

// Der folgende Befehls-Handler stellt die Standardtastatur als
//  Benutzerschnittstelle zum Abbruch der direkten Bearbeitungssitzung zur Verfgung. Hier
//  verursacht der Container (nicht der Server) die Deaktivierung.
void CEx36bView::OnCancelEditCntr()
{
	// Schlieen aller direkt aktiven Elemente dieser Ansicht.
	COleClientItem* pActiveItem = GetDocument()->GetInPlaceActiveItem(this);
	if (pActiveItem != NULL)
	{
		pActiveItem->Close();
	}
	ASSERT(GetDocument()->GetInPlaceActiveItem(this) == NULL);
}

// Fr einen Container mssen OnSetFocus und OnSize speziell gehandhabt werden,
//  wenn ein Objekt direkt bearbeitet wird.
void CEx36bView::OnSetFocus(CWnd* pOldWnd)
{
	COleClientItem* pActiveItem = GetDocument()->GetInPlaceActiveItem(this);
	if (pActiveItem != NULL &&
		pActiveItem->GetItemState() == COleClientItem::activeUIState)
	{
		// dieses Element muss den Fokus erhalten, wenn es sich in der gleichen Ansicht befindet
		CWnd* pWnd = pActiveItem->GetInPlaceWindow();
		if (pWnd != NULL)
		{
			pWnd->SetFocus();    // kein Aufruf der Basisklasse
			return;
		}
	}

	CValidForm::OnSetFocus(pOldWnd);
}

void CEx36bView::OnSize(UINT nType, int cx, int cy)
{
	CValidForm::OnSize(nType, cx, cy);
	COleClientItem* pActiveItem = GetDocument()->GetInPlaceActiveItem(this);
	if (pActiveItem != NULL)
		pActiveItem->SetItemRects();
}

/////////////////////////////////////////////////////////////////////////////
// OLE-Server-Untersttzung

// Der folgende Befehls-Handler stellt die Standardtastatur als
//  Benutzerschnittstelle zum Abbruch der direkten Bearbeitungssitzung zur Verfgung. Hier
//  verursacht der Container (nicht der Server) die Deaktivierung.
void CEx36bView::OnCancelEditSrvr()
{
	GetDocument()->OnDeactivateUI(FALSE);
}

/////////////////////////////////////////////////////////////////////////////
// CEx36bView Diagnose

#ifdef _DEBUG
void CEx36bView::AssertValid() const
{
	CValidForm::AssertValid();
}

void CEx36bView::Dump(CDumpContext& dc) const
{
	CValidForm::Dump(dc);
}

CEx36bDoc* CEx36bView::GetDocument() // Die endgltige (nicht zur Fehlersuche kompilierte) Version ist Inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CEx36bDoc)));
	return (CEx36bDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CEx36bView Nachrichten-Handler

void CEx36bView::OnCancel() 
{
	CEx36bDoc* pDoc = GetDocument();
	m_dHours = 0;
	m_strEmployee = "";
	m_nJob = 0;
	m_nPeriod = pDoc->m_nPeriod;
	UpdateData(FALSE);
}

void CEx36bView::OnSubmit() 
{
	if(UpdateData(TRUE) == TRUE) {
		GetDlgItem(IDC_SUBMIT)->EnableWindow(FALSE);
		CString strHours, strJob, strPeriod;
		strPeriod.Format("%d", m_nPeriod);
		strHours.Format("%3.2f", m_dHours);
		strJob.Format("%d", m_nJob);
		g_strParameters = "Zeitraum=" + strPeriod + "&Mitarbeiter=" + m_strEmployee + "&Stunden=" +
						strHours + "&Position=" + strJob + "\r\n";
		TRACE("Parameterzeichenfolge = %s", g_strParameters);
		AfxBeginThread(PostThreadProc, GetSafeHwnd(), THREAD_PRIORITY_NORMAL);
	}
}

// overridden CValidForm function
void CEx36bView::ValidateDlgItem(CDataExchange* pDX, UINT uID)
{
	ASSERT(this);
	TRACE("CEx36bView::ValidateDlgItem\n");
	switch (uID) {
	case IDC_EMPLOYEE:
		DDX_CBString(pDX, IDC_EMPLOYEE, m_strEmployee);
		// need custom DDV for empty string
		DDV_MaxChars(pDX, m_strEmployee, 10);
		if(m_strEmployee.IsEmpty()) {
			AfxMessageBox("Sie mssen einen Mitarbeiternamen angeben");
			pDX->Fail();
		}
		break;
	case IDC_HOURS:
		DDX_Text(pDX, IDC_HOURS, m_dHours);
		DDV_MinMaxDouble(pDX, m_dHours, 0.1, 100.);
		break;
	case IDC_JOB:
		DDX_Text(pDX, IDC_JOB, m_nJob);
		DDV_MinMaxInt(pDX, m_nJob, 1, 20);
		break;
	default:
		break;
	}
	return;
}

void CEx36bView::OnServerAddress() 
{
	CAddrDialog dlg;
	dlg.m_strServerName = g_strServerName;
	dlg.m_strFile = g_strFile;
	if(dlg.DoModal() == IDOK) {
		g_strFile = dlg.m_strFile;
		g_strServerName = dlg.m_strServerName; 
	}
}

// Thread sendet diese Nachricht; wParam = 1 bei erfolgreicher Ausfhrung
LONG CEx36bView::OnPostComplete(UINT wParam, LONG lParam)
{
	TRACE("CEx36bView::OnPostComplete - %d\n", wParam);
	if(wParam == 0) {
		AfxMessageBox("Der Server hat die Transaktion nicht akzeptiert.");
	}
	else OnCancel();
	GetDlgItem(IDC_SUBMIT)->EnableWindow(TRUE);
	return 0;
}
